module GROESTL_INTERFACE(
   clk, rst_n, 
   load, fetch, 
   odata,  
   busy, start, ack, Ld_msg, 
   hash
);

//{{{ input & output
input clk;
input rst_n;

input load;
input fetch;

output [15:0] odata;

output start;
input busy;

output ack;

output Ld_msg;

input [255:0] hash;
//}}}

//{{{ register

reg [6:0] count;
reg [15:0] odata_r;

reg [2:0] state;
reg [2:0] next_state;

reg ack_r;

//}}}

//{{{ odata
assign odata = odata_r;                                     //output
always @(posedge clk or negedge rst_n)begin
   if (~rst_n) odata_r <= 16'h0000;                     //reset
   else begin
      if (state == 3'b011) begin                       //JE^ɑΉďo͎荞ݕω
         if (count == 'h0) odata_r <= hash[255:240]; 
         else if (count == 'h1) odata_r <= hash[239:224];
         else if (count == 'h2) odata_r <= hash[223:208];
         else if (count == 'h3) odata_r <= hash[207:192];
         else if (count == 'h4) odata_r <= hash[191:176];
         else if (count == 'h5) odata_r <= hash[175:160];
         else if (count == 'h6) odata_r <= hash[159:144];
         else if (count == 'h7) odata_r <= hash[143:128];
         else if (count == 'h8) odata_r <= hash[127:112];
         else if (count == 'h9) odata_r <= hash[111: 96];
         else if (count == 'ha) odata_r <= hash[ 95: 80];
         else if (count == 'hb) odata_r <= hash[ 89: 64];
         else if (count == 'hc) odata_r <= hash[ 63: 48];
         else if (count == 'hd) odata_r <= hash[ 47: 32];
         else if (count == 'he) odata_r <= hash[ 31: 16];
         else if (count == 'hf) odata_r <= hash[ 15:  0];
      end
      else odata_r <= odata_r;
   end
end
//}}}

//{{{ load enable
assign Ld_msg = ((state == 3'b001))? 1:0; 
//}}}

//{{{ data count
always @(posedge clk or negedge rst_n) begin
   if (~rst_n) count <= 0;
   else if ((state == 3'b100) && (count == 7'hf)) count <= 0;
   else if ((state == 3'b001) && (count == 7'h1f)) count <= 0;
   else if ((state == 3'b001) || (state == 3'b100)) count <= count + 1;  
   else count <= count;
end
//}}}

//{{{ ack
assign ack = ack_r;
always @(posedge clk or negedge rst_n)begin
   if (~rst_n) ack_r <= 0;                           //reset
   else begin
      if (state == 3'b011) ack_r <= 1;               //fetchpack 
      else if (state == 3'b001) ack_r <= 1;          //loadpack //#ǉ
      else ack_r <= 0;
   end
end
//}}}

//{{{ start
assign start = ((state == 3'b010) && ack && (count == 7'h00))? 1:0;
//}}}

//{{{ FSM 0:base 1:load_pre 2:load_exe 3:fetch_pre 4:fetch_exe
always @(posedge clk or negedge rst_n)begin
	if (~rst_n) state <= 3'b000;
   else state <= next_state;
end

//gH
always @(load or fetch or state or busy) begin    //ꂩ̐MωƂɔ
   case (state)
      3'b000      : begin                         //Xe[g
         if (load) next_state <= 3'b001;                     
         else if (fetch) next_state <= 3'b011;              
         else next_state <= 3'b000;
      end

      3'b001  : next_state <= 3'b010;             //load_ackXe[g ack𐧌

      3'b010  : begin                             //SHA256_coreNXe[g ENHighɂȂ
         if (~busy) next_state <= 3'b000;         //busyHighȂΑҋ@
         else next_state <= 3'b010;
      end
      
      3'b011 : next_state <= 3'b100;              //fetchXe[g odatahash荞 
      
      3'b100  : next_state <= 3'b000;             //cnt <= cnt + 1;

      default: next_state <= 3'b000;
   endcase
end
//}}}

endmodule 
// vim:fdm=marker
